//
//  CustomView.m
//
//  Code generated using QuartzCode on 8/11/14.
//  www.quartzcodeapp.com
//

#import "CustomView.h"
#import "QCMethod.h"

@interface CustomView ()

@property (nonatomic, strong) CALayer *car;
@property (nonatomic, strong) CALayer *wheel;
@property (nonatomic, strong) CALayer *wheel2;

@end

@implementation CustomView

- (instancetype)initWithFrame:(CGRect)frame
{
	self = [super initWithFrame:frame];
	if (self) {
		[self setupLayers];
	}
	return self;
}

- (instancetype)initWithCoder:(NSCoder *)coder
{
	self = [super initWithCoder:coder];
	if (self) {
		[self setupLayers];
	}
	return self;
}


- (void)setupLayers{
	CALayer * car = [CALayer layer];
	car.anchorPoint = CGPointMake(0.5, 0.9);
	car.frame       = CGRectMake(21.65, 171.09, 215.65, 76.17);
	car.contents    = (id)[UIImage imageNamed:@"car"].CGImage;
	[self.layer addSublayer:car];
	_car = car;
	
	CAEmitterLayer * smoke = [CAEmitterLayer layer];
	smoke.frame                    = CGRectMake(-11.74, -27.98, 90.97, 69.36);
	smoke.emitterPosition          = CGPointMake(0, 69.3594);
	
	CAEmitterCell*  emitter2Cell2 = [CAEmitterCell emitterCell];
	emitter2Cell2.name            = @"emitter2Cell2";
	emitter2Cell2.contents        = (id)[UIImage imageNamed:@"fire2"].CGImage;
	emitter2Cell2.birthRate       = 1000;
	emitter2Cell2.lifetime        = 0.5;
	emitter2Cell2.lifetimeRange   = 1;
	emitter2Cell2.emissionRange   = 3.14;
	emitter2Cell2.velocityRange   = 33;
	emitter2Cell2.xAcceleration   = -130;
	emitter2Cell2.yAcceleration   = -70;
	emitter2Cell2.scale           = 0.07;
	emitter2Cell2.scaleRange      = 0.5;
	
	CAEmitterCell*  emitterCell4  = [CAEmitterCell emitterCell];
	emitterCell4.name            = @"emitterCell4";
	emitterCell4.contents        = (id)[UIImage imageNamed:@"fire2"].CGImage;
	emitterCell4.birthRate       = 45;
	emitterCell4.lifetime        = 0.1;
	emitterCell4.lifetimeRange   = 1;
	emitterCell4.emissionRange   = 3.14;
	emitterCell4.velocity        = 5;
	emitterCell4.velocityRange   = 2;
	emitterCell4.xAcceleration   = -130;
	emitterCell4.yAcceleration   = -70;
	emitterCell4.scale           = 0.07;
	emitterCell4.scaleRange      = 0.5;
	smoke.emitterCells             = @[emitter2Cell2, emitterCell4];
	[car addSublayer:smoke];
	
	CALayer * wheel = [CALayer layer];
	wheel.frame    = CGRectMake(168.45, 40.83, 32.93, 32.93);
	wheel.contents = (id)[UIImage imageNamed:@"wheel"].CGImage;
	[car addSublayer:wheel];
	_wheel = wheel;
	
	CALayer * wheel2 = [CALayer layer];
	wheel2.frame    = CGRectMake(29.37, 43.79, 32.93, 32.93);
	wheel2.contents = (id)[UIImage imageNamed:@"wheel"].CGImage;
	[car addSublayer:wheel2];
	_wheel2 = wheel2;
	
	CAShapeLayer * path = [CAShapeLayer layer];
	path.frame       = CGRectMake(20.65, 248.27, 984.29, 139.05);
	path.fillColor   = nil;
	path.strokeColor = [UIColor blackColor].CGColor;
	path.path        = [self pathPath].CGPath;
	[self.layer addSublayer:path];
}


- (IBAction)startAllAnimations:(id)sender{
	[self.car addAnimation:[self carAnimation] forKey:@"carAnimation"];
	[self.wheel addAnimation:[self wheelAnimation] forKey:@"wheelAnimation"];
	[self.wheel2 addAnimation:[self wheel2Animation] forKey:@"wheel2Animation"];
	[QCMethod updateValueFromAnimationsForLayers:@[self.car, self.wheel, self.wheel2]];
}

- (CAKeyframeAnimation*)carAnimation{
	CAKeyframeAnimation * positionAnim = [CAKeyframeAnimation animationWithKeyPath:@"position"];
	positionAnim.path                  = [QCMethod offsetPath:[self pathPath] by:CGPointMake(20.65, 248.27)].CGPath;
	positionAnim.rotationMode          = kCAAnimationRotateAuto;
	positionAnim.calculationMode       = kCAAnimationPaced;
	positionAnim.duration              = 4.98;
	positionAnim.repeatCount           = INFINITY;
	
	return positionAnim;
}

- (CABasicAnimation*)wheelAnimation{
	CABasicAnimation * transformAnim = [CABasicAnimation animationWithKeyPath:@"transform.rotation"];
	transformAnim.fromValue          = @(0);
	transformAnim.toValue            = @(360 * M_PI/180);
	transformAnim.duration           = 0.587;
	transformAnim.repeatCount        = INFINITY;
	transformAnim.fillMode = kCAFillModeBoth;
	transformAnim.removedOnCompletion = NO;
	
	return transformAnim;
}

- (CABasicAnimation*)wheel2Animation{
	CABasicAnimation * transformAnim = [CABasicAnimation animationWithKeyPath:@"transform.rotation"];
	transformAnim.fromValue          = @(0);
	transformAnim.toValue            = @(360 * M_PI/180);
	transformAnim.duration           = 0.587;
	transformAnim.repeatCount        = INFINITY;
	transformAnim.fillMode = kCAFillModeBoth;
	transformAnim.removedOnCompletion = NO;
	
	return transformAnim;
}

#pragma mark - Bezier Path

- (UIBezierPath*)pathPath{
	UIBezierPath *pathPath = [UIBezierPath bezierPath];
	[pathPath moveToPoint:CGPointMake(0, 0.899)];
	[pathPath addCurveToPoint:CGPointMake(204.168, 9.9264) controlPoint1:CGPointMake(66.6347, 0.899) controlPoint2:CGPointMake(137.7192, -4.209)];
	[pathPath addCurveToPoint:CGPointMake(319.793, 41.524) controlPoint1:CGPointMake(243.2484, 18.2398) controlPoint2:CGPointMake(281.6906, 29.4989)];
	[pathPath addCurveToPoint:CGPointMake(400, 71.7311) controlPoint1:CGPointMake(347.0372, 50.1223) controlPoint2:CGPointMake(373.02, 62.3363)];
	[pathPath addCurveToPoint:CGPointMake(428.4727, 79.3678) controlPoint1:CGPointMake(409.2798, 74.9624) controlPoint2:CGPointMake(418.6494, 79.1243)];
	[pathPath addCurveToPoint:CGPointMake(736.1094, 80.0631) controlPoint1:CGPointMake(530.987, 81.9091) controlPoint2:CGPointMake(633.5781, 78.3346)];
	[pathPath addCurveToPoint:CGPointMake(903.8164, 125.2037) controlPoint1:CGPointMake(795.9637, 81.0722) controlPoint2:CGPointMake(845.2834, 109.8842)];
	[pathPath addCurveToPoint:CGPointMake(984.2891, 139.0514) controlPoint1:CGPointMake(930.1479, 132.0954) controlPoint2:CGPointMake(957.4648, 134.4355)];
	
	return pathPath;
}

@end