//
//  CustomView.swift
//
//  Code generated using QuartzCode on 8/11/14.
//  www.quartzcodeapp.com
//

import UIKit

class CustomView: UIView {
	var car : CALayer!
	var wheel : CALayer!
	var wheel2 : CALayer!
	
	override init(frame: CGRect) {
		super.init(frame: frame)
		setupLayers()
	}
	
	required init(coder aDecoder: NSCoder)
	{
		super.init(coder: aDecoder)
		setupLayers()
	}
	
	func setupLayers(){
		car = CALayer()
		car.anchorPoint = CGPointMake(0.5, 0.9)
		car.frame       = CGRectMake(21.65, 171.09, 215.65, 76.17)
		car.contents    = UIImage(named:"car")?.CGImage
		self.layer.addSublayer(car)
		
		var smoke = CAEmitterLayer()
		smoke.frame                  = CGRectMake(-11.74, -27.98, 90.97, 69.36)
		smoke.emitterPosition        = CGPointMake(0, 69.3594)
		
		var emitter2Cell2           = CAEmitterCell()
		emitter2Cell2.name          = "emitter2Cell2"
		emitter2Cell2.contents      = UIImage(named:"fire2")?.CGImage
		emitter2Cell2.birthRate     = 1000
		emitter2Cell2.lifetime      = 0.5
		emitter2Cell2.lifetimeRange = 1
		emitter2Cell2.emissionRange = 3.14
		emitter2Cell2.velocityRange = 33
		emitter2Cell2.xAcceleration = -130
		emitter2Cell2.yAcceleration = -70
		emitter2Cell2.scale         = 0.07
		emitter2Cell2.scaleRange    = 0.5
		
		var emitterCell4            = CAEmitterCell()
		emitterCell4.name          = "emitterCell4"
		emitterCell4.contents      = UIImage(named:"fire2")?.CGImage
		emitterCell4.birthRate     = 45
		emitterCell4.lifetime      = 0.1
		emitterCell4.lifetimeRange = 1
		emitterCell4.emissionRange = 3.14
		emitterCell4.velocity      = 5
		emitterCell4.velocityRange = 2
		emitterCell4.xAcceleration = -130
		emitterCell4.yAcceleration = -70
		emitterCell4.scale         = 0.07
		emitterCell4.scaleRange    = 0.5
		smoke.emitterCells           = [emitter2Cell2, emitterCell4]
		car.addSublayer(smoke)
		
		wheel = CALayer()
		wheel.frame    = CGRectMake(168.45, 40.83, 32.93, 32.93)
		wheel.contents = UIImage(named:"wheel")?.CGImage
		car.addSublayer(wheel)
		
		wheel2 = CALayer()
		wheel2.frame    = CGRectMake(29.37, 43.79, 32.93, 32.93)
		wheel2.contents = UIImage(named:"wheel")?.CGImage
		car.addSublayer(wheel2)
		
		var path = CAShapeLayer()
		path.frame       = CGRectMake(20.65, 248.27, 984.29, 139.05)
		path.fillColor   = nil
		path.strokeColor = UIColor.blackColor().CGColor
		path.path        = pathPath().CGPath;
		self.layer.addSublayer(path)
	}
	
	
	@IBAction func startAllAnimations(sender: AnyObject!){
		car?.addAnimation(carAnimation(), forKey:"carAnimation")
		wheel?.addAnimation(wheelAnimation(), forKey:"wheelAnimation")
		wheel2?.addAnimation(wheel2Animation(), forKey:"wheel2Animation")
		QCMethod.updateValueFromAnimationsForLayers([car, wheel, wheel2])
	}
	
	func carAnimation() -> CAKeyframeAnimation{
		var positionAnim             = CAKeyframeAnimation(keyPath:"position")
		positionAnim.path            = QCMethod.offsetPath(pathPath(), offset:CGPointMake(20.65, 248.27)).CGPath
		positionAnim.rotationMode    = kCAAnimationRotateAuto
		positionAnim.calculationMode = kCAAnimationPaced
		positionAnim.duration        = 4.98
		positionAnim.repeatCount     = Float.infinity
		
		return positionAnim;
	}
	
	func wheelAnimation() -> CABasicAnimation{
		var transformAnim         = CABasicAnimation(keyPath:"transform.rotation")
		transformAnim.fromValue   = 0;
		transformAnim.toValue     = 360 * CGFloat(M_PI/180);
		transformAnim.duration    = 0.587
		transformAnim.repeatCount = Float.infinity
		transformAnim.fillMode = kCAFillModeBoth
		transformAnim.removedOnCompletion = false
		
		return transformAnim;
	}
	
	func wheel2Animation() -> CABasicAnimation{
		var transformAnim         = CABasicAnimation(keyPath:"transform.rotation")
		transformAnim.fromValue   = 0;
		transformAnim.toValue     = 360 * CGFloat(M_PI/180);
		transformAnim.duration    = 0.587
		transformAnim.repeatCount = Float.infinity
		transformAnim.fillMode = kCAFillModeBoth
		transformAnim.removedOnCompletion = false
		
		return transformAnim;
	}
	
	//MARK: - Bezier Path
	
	func pathPath() -> UIBezierPath{
		var pathPath = UIBezierPath()
		pathPath.moveToPoint(CGPointMake(0, 0.899))
		pathPath.addCurveToPoint(CGPointMake(204.168, 9.9264), controlPoint1:CGPointMake(66.6347, 0.899), controlPoint2:CGPointMake(137.7192, -4.209))
		pathPath.addCurveToPoint(CGPointMake(319.793, 41.524), controlPoint1:CGPointMake(243.2484, 18.2398), controlPoint2:CGPointMake(281.6906, 29.4989))
		pathPath.addCurveToPoint(CGPointMake(400, 71.7311), controlPoint1:CGPointMake(347.0372, 50.1223), controlPoint2:CGPointMake(373.02, 62.3363))
		pathPath.addCurveToPoint(CGPointMake(428.4727, 79.3678), controlPoint1:CGPointMake(409.2798, 74.9624), controlPoint2:CGPointMake(418.6494, 79.1243))
		pathPath.addCurveToPoint(CGPointMake(736.1094, 80.0631), controlPoint1:CGPointMake(530.987, 81.9091), controlPoint2:CGPointMake(633.5781, 78.3346))
		pathPath.addCurveToPoint(CGPointMake(903.8164, 125.2037), controlPoint1:CGPointMake(795.9637, 81.0722), controlPoint2:CGPointMake(845.2834, 109.8842))
		pathPath.addCurveToPoint(CGPointMake(984.2891, 139.0514), controlPoint1:CGPointMake(930.1479, 132.0954), controlPoint2:CGPointMake(957.4648, 134.4355))
		
		return pathPath;
	}

}